diff --git a/src/include/win32dep.h b/src/include/win32dep.h
new file mode 100644
index 0000000..1ed9731
--- /dev/null
+++ b/src/include/win32dep.h
@@ -0,0 +1,25 @@
+#ifndef _WIN32DEP_H_
+#define _WIN32DEP_H_
+
+#ifdef __cplusplus
+extern "C" {
+#endif /* __cplusplus */
+
+char *trousers_getUserDir(void);			//WARNING: code from PhysicsFS
+unsigned int Curl_rand(void);
+void Curl_srand(void);
+void trousers_setenv(const char *name, const char *value, int overwrite);
+void trousers_log(const char *layer, const char *fmt, ...);
+
+#ifndef HAVE_SETENV
+#define setenv( name, value, overwrite) \
+trousers_setenv( name, value, overwrite)
+#define unsetenv( name) \
+setenv (name, "", 1)
+#endif
+
+#ifdef __cplusplus
+}
+#endif /* __cplusplus */
+
+#endif /* _WIN32DEP_H_ */
diff --git a/src/tcs/Makefile.am b/src/tcs/Makefile.am
index 8540a9a..3dd8b68 100644
--- a/src/tcs/Makefile.am
+++ b/src/tcs/Makefile.am
@@ -15,6 +15,9 @@ libtcs_a_SOURCES=log.c \
 		 tcs_auth_mgr.c tcsi_auth.c rpc/@RPC@/rpc_auth.c \
 		 tcs_pbg.c
 
+if OS_WIN32
+libtcs_a_LIBADD+=${top_builddir}/src/win32/libc_interface.la
+endif
 if TSS_BUILD_TRANSPORT
 libtcs_a_SOURCES+=tcsi_transport.c rpc/@RPC@/rpc_transport.c
 libtcs_a_CFLAGS+=-DTSS_BUILD_TRANSPORT
diff --git a/src/tcs/log.c b/src/tcs/log.c
index 8f3d0b4..57a9148 100644
--- a/src/tcs/log.c
+++ b/src/tcs/log.c
@@ -9,12 +9,21 @@
  */
 
 
+#ifdef WIN32
+#include <ws2tcpip.h>
+#include <windows.h>
+#endif
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 
 #include "trousers/tss.h"
 #include "tcslog.h"
+#ifdef WIN32
+#include "libc_interface.h"
+#endif
 
 #ifdef TSS_DEBUG
 
@@ -36,8 +45,10 @@ LogBlobData(char *szDescriptor, unsigned long sizeOfBlob, unsigned char *blob)
 	unsigned int i;
 
 
+#ifndef WIN32
 	if (getenv("TCSD_FOREGROUND") == NULL)
 		openlog(szDescriptor, LOG_NDELAY|LOG_PID, TSS_SYSLOG_LVL);
+#endif
 	memset(temp, 0, sizeof(temp));
 
 	for (i = 0; (unsigned long)i < sizeOfBlob; i++) {
@@ -45,7 +56,11 @@ LogBlobData(char *szDescriptor, unsigned long sizeOfBlob, unsigned char *blob)
 			if (getenv("TCSD_FOREGROUND") != NULL)
 				fprintf(stdout, "%s %s\n", szDescriptor, temp);
 			else
+#ifdef WIN32
+				trousers_log(APPID, "%s\n", temp);
+#else
 				syslog(LOG_DEBUG, "%s", temp);
+#endif
 			memset(temp, 0, sizeof(temp));
 		}
 		snprintf(&temp[(i%16)*3], 4, "%.2X ", blob[i]);
@@ -55,7 +70,11 @@ LogBlobData(char *szDescriptor, unsigned long sizeOfBlob, unsigned char *blob)
 		if (getenv("TCSD_FOREGROUND") != NULL)
 			fprintf(stdout, "%s %s\n", szDescriptor, temp);
 		else
+#ifdef WIN32
+			trousers_log(APPID, "%s\n", temp);
+#else
 			syslog(LOG_DEBUG, "%s", temp);
+#endif
 	}
 }
 
diff --git a/src/tcs/ps/ps_utils.c b/src/tcs/ps/ps_utils.c
index 2e7f502..f96fb99 100644
--- a/src/tcs/ps/ps_utils.c
+++ b/src/tcs/ps/ps_utils.c
@@ -10,7 +10,9 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <sys/types.h>
 #include <sys/stat.h>
 #if defined(HAVE_BYTEORDER_H)
diff --git a/src/tcs/ps/tcsps.c b/src/tcs/ps/tcsps.c
index 00ad435..c2ee6b8 100644
--- a/src/tcs/ps/tcsps.c
+++ b/src/tcs/ps/tcsps.c
@@ -9,13 +9,21 @@
  */
 
 
+#ifdef WIN32
+#include <ws2tcpip.h>
+#include <windows.h>
+#endif
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <errno.h>
 #include <sys/types.h>
+#ifndef WIN32
 #include <sys/file.h>
+#endif
 #include <sys/stat.h>
 #if defined (HAVE_BYTEORDER_H)
 #include <sys/byteorder.h>
@@ -42,11 +50,17 @@
 #include "tcslog.h"
 #include "tcsd_wrap.h"
 #include "tcsd.h"
+#ifdef WIN32
+#include "flock.h"
+#include "libc_interface.h"
+#endif
 
 int system_ps_fd = -1;
 MUTEX_DECLARE(disk_cache_lock);
 
+#if defined (SOLARIS)
 static struct flock fl;
+#endif
 
 int
 get_file()
@@ -56,8 +70,12 @@ get_file()
 	if (system_ps_fd != -1) {
 		int rc = 0;
 
+#if defined (SOLARIS)
 		fl.l_type = F_WRLCK;
 		if ((rc = fcntl(system_ps_fd, F_SETLKW, &fl))) {
+#else
+		if ((rc = flock(system_ps_fd, LOCK_EX))) {
+#endif /* SOLARIS */
 			LogError("failed to get system PS lock: %s", strerror(errno));
 			return -1;
 		}
@@ -66,15 +84,23 @@ get_file()
 	}
 
 	/* open and lock the file */
+#ifdef WIN32
+	system_ps_fd = open(tcsd_options.system_ps_file, O_CREAT|O_RDWR|O_BINARY, 0600);
+#else
 	system_ps_fd = open(tcsd_options.system_ps_file, O_CREAT|O_RDWR, 0600);
+#endif
 	if (system_ps_fd < 0) {
 		LogError("system PS: open() of %s failed: %s",
 				tcsd_options.system_ps_file, strerror(errno));
 		return -1;
 	}
 
+#if defined (SOLARIS)
 	fl.l_type = F_WRLCK;
 	if ((rc = fcntl(system_ps_fd, F_SETLKW, &fl))) {
+#else
+	if ((rc = flock(system_ps_fd, LOCK_EX))) {
+#endif /* SOLARIS */
 		LogError("failed to get system PS lock of file %s: %s",
 			tcsd_options.system_ps_file, strerror(errno));
 		return -1;
@@ -89,8 +115,12 @@ put_file(int fd)
 	int rc = 0;
 	/* release the file lock */
 	
+#if defined (SOLARIS)
 	fl.l_type = F_UNLCK;
 	if ((rc = fcntl(fd, F_SETLKW, &fl))) {
+#else
+	if ((rc = flock(fd, LOCK_UN))) {
+#endif /* SOLARIS */
 		LogError("failed to unlock system PS file: %s",
 			strerror(errno));
 		return -1;
diff --git a/src/tcs/rpc/tcstp/rpc.c b/src/tcs/rpc/tcstp/rpc.c
index ca1a4df..26c5a06 100644
--- a/src/tcs/rpc/tcstp/rpc.c
+++ b/src/tcs/rpc/tcstp/rpc.c
@@ -7,12 +7,19 @@
  * (C) Copyright International Business Machines Corp. 2004-2007
  *
  */
-
+#ifdef WIN32
+#include <ws2tcpip.h>
+#include <windows.h>
+#endif
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 #if (defined (__OpenBSD__) || defined (__FreeBSD__))
 #include <sys/types.h>
 #include <sys/socket.h>
@@ -30,6 +37,9 @@
 #include "tcsd.h"
 #include "rpc_tcstp_tcs.h"
 
+#ifdef WIN32
+#include "libc_interface.h"
+#endif
 
 /* Lock is not static because we need to reference it in the auth manager */
 MUTEX_DECLARE_INIT(tcsp_lock);
@@ -59,7 +69,7 @@ recv_from_socket(int sock, void *buffer, int size)
 
 	while (recv_total < size) {
 		errno = 0;
-		if ((recv_size = recv(sock, buffer+recv_total, size-recv_total, 0)) <= 0) {
+		if ((recv_size = recv(sock, (char *)buffer+recv_total, size-recv_total, 0)) <= 0) {
 			if (recv_size < 0) {
 				if (errno == EINTR)
 					continue;
@@ -82,7 +92,7 @@ send_to_socket(int sock, void *buffer, int size)
 	int send_size = 0, send_total = 0;
 
 	while (send_total < size) {
-		if ((send_size = send(sock, buffer+send_total, size-send_total, 0)) < 0) {
+		if ((send_size = send(sock, (char *)buffer+send_total, size-send_total, 0)) < 0) {
 			LogError("Socket send connection error: %s.", strerror(errno));
 			return -1;
 		}
diff --git a/src/tcs/rpc/tcstp/rpc_admin.c b/src/tcs/rpc/tcstp/rpc_admin.c
index 4f357c3..17913be 100644
--- a/src/tcs/rpc/tcstp/rpc_admin.c
+++ b/src/tcs/rpc/tcstp/rpc_admin.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_aik.c b/src/tcs/rpc/tcstp/rpc_aik.c
index 0f758f9..c8e841a 100644
--- a/src/tcs/rpc/tcstp/rpc_aik.c
+++ b/src/tcs/rpc/tcstp/rpc_aik.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_audit.c b/src/tcs/rpc/tcstp/rpc_audit.c
index 0fcfd18..237e5fb 100644
--- a/src/tcs/rpc/tcstp/rpc_audit.c
+++ b/src/tcs/rpc/tcstp/rpc_audit.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_auth.c b/src/tcs/rpc/tcstp/rpc_auth.c
index 2437c6b..9d378be 100644
--- a/src/tcs/rpc/tcstp/rpc_auth.c
+++ b/src/tcs/rpc/tcstp/rpc_auth.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_bind.c b/src/tcs/rpc/tcstp/rpc_bind.c
index 92eee24..8192aed 100644
--- a/src/tcs/rpc/tcstp/rpc_bind.c
+++ b/src/tcs/rpc/tcstp/rpc_bind.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_caps.c b/src/tcs/rpc/tcstp/rpc_caps.c
index 4fd2c11..9bd45e5 100644
--- a/src/tcs/rpc/tcstp/rpc_caps.c
+++ b/src/tcs/rpc/tcstp/rpc_caps.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_caps_tpm.c b/src/tcs/rpc/tcstp/rpc_caps_tpm.c
index 2bcac27..2aa74a4 100644
--- a/src/tcs/rpc/tcstp/rpc_caps_tpm.c
+++ b/src/tcs/rpc/tcstp/rpc_caps_tpm.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_certify.c b/src/tcs/rpc/tcstp/rpc_certify.c
index 85c9321..f89b1df 100644
--- a/src/tcs/rpc/tcstp/rpc_certify.c
+++ b/src/tcs/rpc/tcstp/rpc_certify.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_changeauth.c b/src/tcs/rpc/tcstp/rpc_changeauth.c
index 97af192..9d1dd13 100644
--- a/src/tcs/rpc/tcstp/rpc_changeauth.c
+++ b/src/tcs/rpc/tcstp/rpc_changeauth.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_cmk.c b/src/tcs/rpc/tcstp/rpc_cmk.c
index 3d00c13..1d2eb96 100644
--- a/src/tcs/rpc/tcstp/rpc_cmk.c
+++ b/src/tcs/rpc/tcstp/rpc_cmk.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_context.c b/src/tcs/rpc/tcstp/rpc_context.c
index b04449e..387c81b 100644
--- a/src/tcs/rpc/tcstp/rpc_context.c
+++ b/src/tcs/rpc/tcstp/rpc_context.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_counter.c b/src/tcs/rpc/tcstp/rpc_counter.c
index 6bb654e..27e9185 100644
--- a/src/tcs/rpc/tcstp/rpc_counter.c
+++ b/src/tcs/rpc/tcstp/rpc_counter.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_daa.c b/src/tcs/rpc/tcstp/rpc_daa.c
index 6da24a1..0c59403 100644
--- a/src/tcs/rpc/tcstp/rpc_daa.c
+++ b/src/tcs/rpc/tcstp/rpc_daa.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
@@ -41,10 +45,9 @@ tcs_wrap_DaaJoin(struct tcsd_thread_data *data)
 	if (getData(TCSD_PACKET_TYPE_UINT32, 0, &hContext, 0, &data->comm))
 		return TCSERR(TSS_E_INTERNAL_ERROR);
 
-	LogDebugFn("thread %ld hDAA %x", THREAD_ID, hDAA);
-
 	if (getData(TCSD_PACKET_TYPE_UINT32, 1, &hDAA, 0, &data->comm))
 		return TCSERR(TSS_E_INTERNAL_ERROR);
+	LogDebugFn("thread %ld hDAA %x", THREAD_ID, hDAA);
 
 	if (getData(TCSD_PACKET_TYPE_BYTE, 2, &stage, 0, &data->comm))
 		return TCSERR(TSS_E_INTERNAL_ERROR);
@@ -145,9 +148,9 @@ tcs_wrap_DaaSign(struct tcsd_thread_data *data)
 	if (getData(TCSD_PACKET_TYPE_UINT32, 0, &hContext, 0, &data->comm))
 		return TCSERR(TSS_E_INTERNAL_ERROR);
 
-	LogDebugFn("thread %ld hDAA %x", THREAD_ID, hDAA);
 	if (getData(TCSD_PACKET_TYPE_UINT32, 1, &hDAA, 0, &data->comm))
 		return TCSERR(TSS_E_INTERNAL_ERROR);
+	LogDebugFn("thread %ld hDAA %x", THREAD_ID, hDAA);
 
 	if (getData(TCSD_PACKET_TYPE_BYTE, 2, &stage, 0, &data->comm))
 		return TCSERR(TSS_E_INTERNAL_ERROR);
diff --git a/src/tcs/rpc/tcstp/rpc_delegate.c b/src/tcs/rpc/tcstp/rpc_delegate.c
index 5bd0cd8..ba77d1b 100644
--- a/src/tcs/rpc/tcstp/rpc_delegate.c
+++ b/src/tcs/rpc/tcstp/rpc_delegate.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_dir.c b/src/tcs/rpc/tcstp/rpc_dir.c
index 47baec6..4040caa 100644
--- a/src/tcs/rpc/tcstp/rpc_dir.c
+++ b/src/tcs/rpc/tcstp/rpc_dir.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_ek.c b/src/tcs/rpc/tcstp/rpc_ek.c
index 0b49718..f44bc14 100644
--- a/src/tcs/rpc/tcstp/rpc_ek.c
+++ b/src/tcs/rpc/tcstp/rpc_ek.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_evlog.c b/src/tcs/rpc/tcstp/rpc_evlog.c
index 4187c25..b9b22e5 100644
--- a/src/tcs/rpc/tcstp/rpc_evlog.c
+++ b/src/tcs/rpc/tcstp/rpc_evlog.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_key.c b/src/tcs/rpc/tcstp/rpc_key.c
index d3a5153..e8d1434 100644
--- a/src/tcs/rpc/tcstp/rpc_key.c
+++ b/src/tcs/rpc/tcstp/rpc_key.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_maint.c b/src/tcs/rpc/tcstp/rpc_maint.c
index f51a4f2..ee28621 100644
--- a/src/tcs/rpc/tcstp/rpc_maint.c
+++ b/src/tcs/rpc/tcstp/rpc_maint.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_migration.c b/src/tcs/rpc/tcstp/rpc_migration.c
index 5233096..722248f 100644
--- a/src/tcs/rpc/tcstp/rpc_migration.c
+++ b/src/tcs/rpc/tcstp/rpc_migration.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_nv.c b/src/tcs/rpc/tcstp/rpc_nv.c
index 71c170d..77d0443 100644
--- a/src/tcs/rpc/tcstp/rpc_nv.c
+++ b/src/tcs/rpc/tcstp/rpc_nv.c
@@ -25,9 +25,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_oper.c b/src/tcs/rpc/tcstp/rpc_oper.c
index 8e097be..41a9882 100644
--- a/src/tcs/rpc/tcstp/rpc_oper.c
+++ b/src/tcs/rpc/tcstp/rpc_oper.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_own.c b/src/tcs/rpc/tcstp/rpc_own.c
index beb2a8c..cfe6268 100644
--- a/src/tcs/rpc/tcstp/rpc_own.c
+++ b/src/tcs/rpc/tcstp/rpc_own.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_pcr_extend.c b/src/tcs/rpc/tcstp/rpc_pcr_extend.c
index e9fd9cd..855d3b2 100644
--- a/src/tcs/rpc/tcstp/rpc_pcr_extend.c
+++ b/src/tcs/rpc/tcstp/rpc_pcr_extend.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_ps.c b/src/tcs/rpc/tcstp/rpc_ps.c
index 3f6e5a7..e6eb500 100644
--- a/src/tcs/rpc/tcstp/rpc_ps.c
+++ b/src/tcs/rpc/tcstp/rpc_ps.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_quote.c b/src/tcs/rpc/tcstp/rpc_quote.c
index aeb469c..6307304 100644
--- a/src/tcs/rpc/tcstp/rpc_quote.c
+++ b/src/tcs/rpc/tcstp/rpc_quote.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_quote2.c b/src/tcs/rpc/tcstp/rpc_quote2.c
index 2a10ead..a122fc1 100644
--- a/src/tcs/rpc/tcstp/rpc_quote2.c
+++ b/src/tcs/rpc/tcstp/rpc_quote2.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_random.c b/src/tcs/rpc/tcstp/rpc_random.c
index 6fd9606..00747e1 100644
--- a/src/tcs/rpc/tcstp/rpc_random.c
+++ b/src/tcs/rpc/tcstp/rpc_random.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_seal.c b/src/tcs/rpc/tcstp/rpc_seal.c
index f0dd359..5392a0d 100644
--- a/src/tcs/rpc/tcstp/rpc_seal.c
+++ b/src/tcs/rpc/tcstp/rpc_seal.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_selftest.c b/src/tcs/rpc/tcstp/rpc_selftest.c
index 4cad0c9..d9ebaa7 100644
--- a/src/tcs/rpc/tcstp/rpc_selftest.c
+++ b/src/tcs/rpc/tcstp/rpc_selftest.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_sign.c b/src/tcs/rpc/tcstp/rpc_sign.c
index 2cd2027..bc40459 100644
--- a/src/tcs/rpc/tcstp/rpc_sign.c
+++ b/src/tcs/rpc/tcstp/rpc_sign.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_tick.c b/src/tcs/rpc/tcstp/rpc_tick.c
index 98e53ad..c998f21 100644
--- a/src/tcs/rpc/tcstp/rpc_tick.c
+++ b/src/tcs/rpc/tcstp/rpc_tick.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/rpc/tcstp/rpc_transport.c b/src/tcs/rpc/tcstp/rpc_transport.c
index 1993cb3..a7c4128 100644
--- a/src/tcs/rpc/tcstp/rpc_transport.c
+++ b/src/tcs/rpc/tcstp/rpc_transport.c
@@ -10,9 +10,13 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <string.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcs_aik.c b/src/tcs/tcs_aik.c
index 1d22506..b05e4e3 100644
--- a/src/tcs/tcs_aik.c
+++ b/src/tcs/tcs_aik.c
@@ -12,10 +12,14 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <sys/types.h>
 #include <sys/stat.h>
+#ifndef WIN32
 #include <sys/mman.h>
+#endif
 #include <fcntl.h>
 #include <errno.h>
 
@@ -85,7 +89,6 @@ get_credential(UINT32 type, UINT32 *size, BYTE **cred)
 {
 	int rc, fd;
 	char *path = NULL;
-	void *file = NULL;
 	struct stat stat_buf;
 	size_t file_size;
 
@@ -121,23 +124,15 @@ get_credential(UINT32 type, UINT32 *size, BYTE **cred)
 
 	LogDebugFn("%s, (%zd bytes)", path, file_size);
 
-	file = mmap(0, file_size, PROT_READ, MAP_PRIVATE, fd, 0);
-	if (file == MAP_FAILED) {
-		LogError("Error reading credential: %s: %s", path, strerror(errno));
-		close(fd);
-		goto done;
-	}
-	close(fd);
-
-	if ((*cred = malloc(file_size)) == NULL) {
+	if ((*cred = malloc(file_size + 1)) == NULL) {
 		LogError("malloc of %zd bytes failed.", file_size);
-		munmap(file, file_size);
 		goto done;
 	}
 
-	memcpy(*cred, file, file_size);
+	memset(*cred, 0, file_size + 1);
+	read(fd, *cred, file_size);
+	close(fd);
 	*size = file_size;
-	munmap(file, file_size);
 
 	return;
 done:
diff --git a/src/tcs/tcs_caps.c b/src/tcs/tcs_caps.c
index c4cff7c..1ce245b 100644
--- a/src/tcs/tcs_caps.c
+++ b/src/tcs/tcs_caps.c
@@ -12,10 +12,14 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <sys/types.h>
 #include <sys/stat.h>
+#ifndef WIN32
 #include <sys/mman.h>
+#endif
 #include <fcntl.h>
 #include <errno.h>
 
diff --git a/src/tcs/tcs_counter.c b/src/tcs/tcs_counter.c
index f212ac6..a73d6fc 100644
--- a/src/tcs/tcs_counter.c
+++ b/src/tcs/tcs_counter.c
@@ -12,10 +12,14 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <sys/types.h>
 #include <sys/stat.h>
+#ifndef WIN32
 #include <sys/mman.h>
+#endif
 #include <fcntl.h>
 #include <errno.h>
 
diff --git a/src/tcs/tcs_evlog_biosem.c b/src/tcs/tcs_evlog_biosem.c
index 7065e12..9c1f344 100644
--- a/src/tcs/tcs_evlog_biosem.c
+++ b/src/tcs/tcs_evlog_biosem.c
@@ -23,7 +23,9 @@
 #include <fcntl.h>
 #include <errno.h>
 #include <limits.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcs_evlog_imaem.c b/src/tcs/tcs_evlog_imaem.c
index fbdd29a..6f19d6c 100644
--- a/src/tcs/tcs_evlog_imaem.c
+++ b/src/tcs/tcs_evlog_imaem.c
@@ -36,7 +36,9 @@
 #include <fcntl.h>
 #include <errno.h>
 #include <limits.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
@@ -84,7 +86,7 @@ ima_get_entries_by_pcr(FILE *handle, UINT32 pcr_index, UINT32 first,
 	struct event_wrapper *cur = list;
 	TSS_RESULT result = TCSERR(TSS_E_INTERNAL_ERROR);
 	FILE *fp = (FILE *) handle;
-	uint len;
+	unsigned int len;
 	char name[255];
 
 	if (list == NULL) {
@@ -226,7 +228,7 @@ TSS_RESULT
 ima_get_entry(FILE *handle, UINT32 pcr_index, UINT32 *num, TSS_PCR_EVENT **ppEvent)
 {
 	int pcr_value, ptr = 0;
-	uint len;
+	unsigned int len;
 	char page[IMA_READ_SIZE];
 	UINT32 seen_indices = 0;
 	TSS_RESULT result = TCSERR(TSS_E_INTERNAL_ERROR);
diff --git a/src/tcs/tcs_key_mem_cache.c b/src/tcs/tcs_key_mem_cache.c
index a44278e..185a8e0 100644
--- a/src/tcs/tcs_key_mem_cache.c
+++ b/src/tcs/tcs_key_mem_cache.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <errno.h>
 
 #include "trousers/tss.h"
diff --git a/src/tcs/tcs_key_ps.c b/src/tcs/tcs_key_ps.c
index 0ea28c1..e165492 100644
--- a/src/tcs/tcs_key_ps.c
+++ b/src/tcs/tcs_key_ps.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <errno.h>
 
 #include "trousers/tss.h"
diff --git a/src/tcs/tcs_migration.c b/src/tcs/tcs_migration.c
index f653737..f4e92f1 100644
--- a/src/tcs/tcs_migration.c
+++ b/src/tcs/tcs_migration.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcs_pbg.c b/src/tcs/tcs_pbg.c
index 5eaa6f7..5050d09 100644
--- a/src/tcs/tcs_pbg.c
+++ b/src/tcs/tcs_pbg.c
@@ -13,10 +13,14 @@
 #include <stdio.h>
 #include <stdarg.h>
 #include <string.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <sys/types.h>
 #include <sys/stat.h>
+#ifndef WIN32
 #include <sys/mman.h>
+#endif
 #include <fcntl.h>
 #include <errno.h>
 
@@ -916,6 +920,7 @@ TSS_RESULT
 tpm_rqu_build(TPM_COMMAND_CODE ordinal, UINT64 *outOffset, BYTE *out_blob, ...)
 {
 	TSS_RESULT result = TSS_SUCCESS;
+	UINT64 blob_size;
 	va_list ap;
 
 	DBG_ASSERT(ordinal);
@@ -1448,6 +1453,13 @@ tpm_rqu_build(TPM_COMMAND_CODE ordinal, UINT64 *outOffset, BYTE *out_blob, ...)
 		TPM_AUTH *auth1 = va_arg(ap, TPM_AUTH *);
 		va_end(ap);
 
+		blob_size = in_len1 + in_len2 + TPM_DIGEST_SIZE + sizeof(TPM_AUTH);
+		if (blob_size > TSS_TPM_TXBLOB_SIZE) {
+			result = TCSERR(TSS_E_BAD_PARAMETER);
+			LogError("Oversized input when building ordinal 0x%x", ordinal);
+			break;
+		}
+				
 		if (!keySlot1 || !in_blob2 || !auth1) {
 			result = TCSERR(TSS_E_INTERNAL_ERROR);
 			LogError("Internal error for ordinal 0x%x", ordinal);
diff --git a/src/tcs/tcs_quote.c b/src/tcs/tcs_quote.c
index 0c84687..21f0530 100644
--- a/src/tcs/tcs_quote.c
+++ b/src/tcs/tcs_quote.c
@@ -12,10 +12,14 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <sys/types.h>
 #include <sys/stat.h>
+#ifndef WIN32
 #include <sys/mman.h>
+#endif
 #include <fcntl.h>
 #include <errno.h>
 
diff --git a/src/tcs/tcs_quote2.c b/src/tcs/tcs_quote2.c
index aa7ba51..d62ec98 100644
--- a/src/tcs/tcs_quote2.c
+++ b/src/tcs/tcs_quote2.c
@@ -12,10 +12,14 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <sys/types.h>
 #include <sys/stat.h>
+#ifndef WIN32
 #include <sys/mman.h>
+#endif
 #include <fcntl.h>
 #include <errno.h>
 
diff --git a/src/tcs/tcs_req_mgr.c b/src/tcs/tcs_req_mgr.c
index 701cedb..1b02c5a 100644
--- a/src/tcs/tcs_req_mgr.c
+++ b/src/tcs/tcs_req_mgr.c
@@ -11,11 +11,15 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <signal.h>
 #include <string.h>
 #include <errno.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 
 #include "trousers/tss.h"
 #include "tcs_tsp.h"
diff --git a/src/tcs/tcs_seal.c b/src/tcs/tcs_seal.c
index e021948..01de608 100644
--- a/src/tcs/tcs_seal.c
+++ b/src/tcs/tcs_seal.c
@@ -12,10 +12,14 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <sys/types.h>
 #include <sys/stat.h>
+#ifndef WIN32
 #include <sys/mman.h>
+#endif
 #include <fcntl.h>
 #include <errno.h>
 
diff --git a/src/tcs/tcs_utils.c b/src/tcs/tcs_utils.c
index d621ef8..8da0549 100644
--- a/src/tcs/tcs_utils.c
+++ b/src/tcs/tcs_utils.c
@@ -12,10 +12,14 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <sys/types.h>
 #include <sys/stat.h>
+#ifndef WIN32
 #include <sys/mman.h>
+#endif
 #include <fcntl.h>
 #include <errno.h>
 
diff --git a/src/tcs/tcsi_admin.c b/src/tcs/tcsi_admin.c
index 3830b12..1fbec1d 100644
--- a/src/tcs/tcsi_admin.c
+++ b/src/tcs/tcsi_admin.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
@@ -171,7 +173,11 @@ TCSP_PhysicalPresence_Internal(TCS_CONTEXT_HANDLE hContext, /* in */
 	BYTE txBlob[TSS_TPM_TXBLOB_SIZE];
 	char runlevel;
 
+#ifdef FIXME
 	runlevel = platform_get_runlevel();
+#else
+	runlevel = 3;
+#endif
 
 	if (runlevel != 's' && runlevel != 'S' && runlevel != '1') {
 		LogInfo("Physical Presence command denied: Must be in single"
diff --git a/src/tcs/tcsi_aik.c b/src/tcs/tcsi_aik.c
index 8915d13..20a83fe 100644
--- a/src/tcs/tcsi_aik.c
+++ b/src/tcs/tcsi_aik.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcsi_auth.c b/src/tcs/tcsi_auth.c
index ec4a11e..63b4a99 100644
--- a/src/tcs/tcsi_auth.c
+++ b/src/tcs/tcsi_auth.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcsi_bind.c b/src/tcs/tcsi_bind.c
index 7c9fb46..e512d96 100644
--- a/src/tcs/tcsi_bind.c
+++ b/src/tcs/tcsi_bind.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcsi_caps.c b/src/tcs/tcsi_caps.c
index 2d7684f..117b92d 100644
--- a/src/tcs/tcsi_caps.c
+++ b/src/tcs/tcsi_caps.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcsi_caps_tpm.c b/src/tcs/tcsi_caps_tpm.c
index c64513f..d74a1b7 100644
--- a/src/tcs/tcsi_caps_tpm.c
+++ b/src/tcs/tcsi_caps_tpm.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcsi_certify.c b/src/tcs/tcsi_certify.c
index 8fae84e..fdc951e 100644
--- a/src/tcs/tcsi_certify.c
+++ b/src/tcs/tcsi_certify.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcsi_changeauth.c b/src/tcs/tcsi_changeauth.c
index 59329ea..0c9a7a0 100644
--- a/src/tcs/tcsi_changeauth.c
+++ b/src/tcs/tcsi_changeauth.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcsi_daa.c b/src/tcs/tcsi_daa.c
index 293f4b3..a43f603 100644
--- a/src/tcs/tcsi_daa.c
+++ b/src/tcs/tcsi_daa.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
